import { Injectable, ɵɵdefineInjectable, Component, Pipe, forwardRef, Input, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR, FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/my-bootstrap.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MyBootstrapService {
    constructor() { }
}
MyBootstrapService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
MyBootstrapService.ctorParameters = () => [];
/** @nocollapse */ MyBootstrapService.ngInjectableDef = ɵɵdefineInjectable({ factory: function MyBootstrapService_Factory() { return new MyBootstrapService(); }, token: MyBootstrapService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * Generated from: lib/my-bootstrap.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MyBootstrapComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
MyBootstrapComponent.decorators = [
    { type: Component, args: [{
                selector: 'mb-my-bootstrap',
                template: `
    <p>
      my-bootstrap works!
    </p>
  `
            }] }
];
/** @nocollapse */
MyBootstrapComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/combo-box/combo-box-pipe-filter.pipe.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ComboBoxPipeFilterPipe {
    /**
     * @param {?} items
     * @param {?} itemTextField
     * @param {?} text
     * @return {?}
     */
    transform(items, itemTextField, text) {
        // if (text.length === 0) {
        //   return items;
        // }
        return items.filter((/**
         * @param {?} item
         * @return {?}
         */
        item => {
            /** @type {?} */
            const itemText = item[itemTextField];
            return itemText.toLowerCase().startsWith(text.toLowerCase()) === true;
        }));
    }
}
ComboBoxPipeFilterPipe.decorators = [
    { type: Pipe, args: [{
                name: 'comboBoxFilter'
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/combo-box/combo-box.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const KEY_CODE = {
    UP_ARROW: 38,
    DOWN_ARROW: 40,
    TAB_KEY: 9,
};
KEY_CODE[KEY_CODE.UP_ARROW] = 'UP_ARROW';
KEY_CODE[KEY_CODE.DOWN_ARROW] = 'DOWN_ARROW';
KEY_CODE[KEY_CODE.TAB_KEY] = 'TAB_KEY';
class ComboBoxComponent {
    /**
     * @param {?} comboBoxPipeFilterPipe
     */
    constructor(comboBoxPipeFilterPipe) {
        this.comboBoxPipeFilterPipe = comboBoxPipeFilterPipe;
        this.propagateChangeToForm = (/**
         * @param {?} _
         * @return {?}
         */
        (_) => { });
        this.propagateTouchedToForm = (/**
         * @return {?}
         */
        () => { });
    }
    /**
     * @return {?}
     */
    onFocusEventAction() {
        this.counter = -1;
    }
    /**
     * @return {?}
     */
    onBlurEventAction() {
        this.showDropDown = false;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onKeyDownAction(event) {
        this.showDropDown = true;
        if (event.keyCode === KEY_CODE.UP_ARROW) {
            this.counter = (this.counter === 0) ? this.counter : --this.counter;
            // this.checkHighlight(this.counter);
            this.textToSort = this.dataList[this.counter][this.columnName];
        }
        if (event.keyCode === KEY_CODE.DOWN_ARROW) {
            this.counter = (this.counter === this.dataList.length - 1) ? this.counter : ++this.counter;
            // this.checkHighlight(this.counter);
            this.textToSort = this.dataList[this.counter][this.columnName];
        }
    }
    /**
     * @param {?} currentItem
     * @return {?}
     */
    checkHighlight(currentItem) {
        if (this.counter === currentItem) {
            return true;
        }
        else {
            return false;
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.reset();
    }
    /**
     * @return {?}
     */
    toogleDropDown() {
        this.showDropDown = !this.showDropDown;
        this.propagateTouchedToForm();
    }
    /**
     * @return {?}
     */
    reset() {
        this.showDropDown = false;
        this.dummyDataList = this.dataList;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    textChange(value) {
        this.dummyDataList = [];
        if (value.length > 0) {
            this.dummyDataList = this.comboBoxPipeFilterPipe.transform(this.dataList, this.columnName, value);
        }
        if (this.dummyDataList) {
            this.showDropDown = true;
        }
        else {
            this.reset();
        }
    }
    /**
     * @param {?} valueSelected
     * @return {?}
     */
    updateTextBox(valueSelected) {
        this.textToSort = valueSelected;
        this.showDropDown = false;
        this.propagateChangeToForm(valueSelected);
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    writeValue(obj) {
        this.textToSort = obj;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.propagateChangeToForm = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.propagateTouchedToForm = fn;
    }
}
ComboBoxComponent.decorators = [
    { type: Component, args: [{
                selector: 'mb-combo-box',
                template: "<div class=\"combo-box\">\n  <span class=\"drop-down\">\n    <input type=\"text\"\n           class=\"input-control\"\n           [ngModel]=\"textToSort\"\n           (ngModelChange)=\"textChange($event)\"\n           (keyup)=\"onKeyDownAction($event)\"\n           (focus)=\"onFocusEventAction()\"\n           (blur)=\"onBlurEventAction()\"/>\n    <button class=\"drop-down-button\"\n            (click)=\"toogleDropDown()\">\n            <i class=\"fa fa-angle-down\"></i>\n    </button>\n  </span>\n  <div class=\"data-container\" *ngIf=\"showDropDown\">\n    <p *ngFor=\"let data of dummyDataList; let i=index\"\n       class=\"data-list\"\n       (click)=\"updateTextBox(data[columnName])\"\n       [ngClass]=\"{highlight:checkHighlight(i)}\">\n      {{data[columnName]}}\n    </p>\n\n  </div>\n</div>\n\n",
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef((/**
                         * @return {?}
                         */
                        () => ComboBoxComponent)),
                        multi: true,
                    },
                ],
                styles: [".combo-container{position:fixed;background:#fff}.input-control{width:165px;border:none}.data-container{width:196px;background:#fff;display:block;position:relative;border:1px solid grey;height:200px;overflow-y:scroll;top:0}.data-list{cursor:pointer;margin-top:2px;margin-bottom:2px}.drop-down{border:1px solid grey;width:197px;z-index:2;padding:5px}.drop-down-button{border:none;background:#fff;overflow:hidden}.highlight{background:grey}"]
            }] }
];
/** @nocollapse */
ComboBoxComponent.ctorParameters = () => [
    { type: ComboBoxPipeFilterPipe }
];
ComboBoxComponent.propDecorators = {
    dataList: [{ type: Input }],
    columnName: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    ComboBoxComponent.prototype.dataList;
    /** @type {?} */
    ComboBoxComponent.prototype.columnName;
    /** @type {?} */
    ComboBoxComponent.prototype.dummyDataList;
    /** @type {?} */
    ComboBoxComponent.prototype.showDropDown;
    /** @type {?} */
    ComboBoxComponent.prototype.counter;
    /** @type {?} */
    ComboBoxComponent.prototype.textToSort;
    /**
     * @type {?}
     * @private
     */
    ComboBoxComponent.prototype.propagateChangeToForm;
    /**
     * @type {?}
     * @private
     */
    ComboBoxComponent.prototype.propagateTouchedToForm;
    /**
     * @type {?}
     * @private
     */
    ComboBoxComponent.prototype.comboBoxPipeFilterPipe;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/my-bootstrap.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MyBootstrapModule {
}
MyBootstrapModule.decorators = [
    { type: NgModule, args: [{
                declarations: [MyBootstrapComponent, ComboBoxComponent, ComboBoxPipeFilterPipe],
                imports: [BrowserModule,
                    FormsModule
                ],
                exports: [MyBootstrapComponent, ComboBoxComponent, ComboBoxPipeFilterPipe],
                providers: [ComboBoxPipeFilterPipe],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: my-bootstrap.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { MyBootstrapComponent, MyBootstrapModule, MyBootstrapService, ComboBoxComponent as ɵa, ComboBoxPipeFilterPipe as ɵb };
//# sourceMappingURL=my-bootstrap.js.map
